package com.esignlive.guidance.forum;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.nio.file.Files;

import org.json.JSONObject;

public class _08_29_replace_default_consent_REST {
	public static final String API_KEY = "your_api_key";
	public static final String API_URL = "https://sandbox.esignlive.com/api";
	public static final String PAYLOAD_JSON = "{\"consent\": \"default-consent1\", \"description\": \"\", \"documents\": [{\"id\": \"default-consent1\", \"approvals\": [], \"index\": 0, \"description\": \"my customized desc.\", \"name\": \"my customized name\"}], \"language\": \"en\", \"name\": \"Test Uploading Default Consent\", \"status\": \"DRAFT\", \"type\": \"PACKAGE\", \"timezoneId\": \"GMT\"}";
	public static final String FILE_PATH = "your_file_path\\SampleDoc1.pdf";

	public static void main(String[] args) {
		try {
			new _08_29_replace_default_consent_REST().execute();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private void execute() throws IOException {
		URL sourceClient = new URL(API_URL + "/packages/");
		String boundary = "InfBound1x$y$tems";
		String CRLF = "\r\n"; // Line separator used in multipart/form-data.
		String charset = "UTF-8";

		HttpURLConnection sourceConn = (HttpURLConnection) sourceClient.openConnection();
		sourceConn.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);
		sourceConn.setRequestProperty("Accept", "application/json; esl-api-version=11.21");
		sourceConn.setRequestProperty("Authorization", "Basic " + API_KEY);
		
		sourceConn.setRequestMethod("POST");
		sourceConn.setDoOutput(true);
		sourceConn.setDoInput(true);
		
		
		//output data
		OutputStream output = sourceConn.getOutputStream();
		PrintWriter writer = new PrintWriter(new OutputStreamWriter(output), true);
		try {

			// Add pdf file.
			File uploadFile1 = new File(FILE_PATH);
			writer.append("--" + boundary).append(CRLF);
			writer.append("Content-Disposition: form-data; name=\"file\"; filename=\"default-consent\"")
					.append(CRLF);
			writer.append("Content-Type: " + URLConnection.guessContentTypeFromName(uploadFile1.getName()))
					.append(CRLF);
			writer.append(CRLF).flush();
			Files.copy(uploadFile1.toPath(), output);
			output.flush();
			writer.append(CRLF).flush();
			
			// add json payload
			writer.append("--" + boundary).append(CRLF);
			writer.append("Content-Disposition: form-data; name=\"payload\"").append(CRLF);
			writer.append("Content-Type: application/json; charset=" + charset).append(CRLF);
			writer.append(CRLF).append(PAYLOAD_JSON).append(CRLF).flush();

			// End of multipart/form-data.
			writer.append("--" + boundary + "--").append(CRLF).flush();
		} 
		catch (Exception ex) {
			throw ex;
		}

		int sourceResponseCode = ((HttpURLConnection) sourceConn).getResponseCode();
		if (sourceResponseCode == 200) {
			BufferedReader in = new BufferedReader(new InputStreamReader(sourceConn.getInputStream()));
			String inputLine;
			StringBuffer response = new StringBuffer();

			while ((inputLine = in.readLine()) != null) {
				response.append(inputLine);
			}

			in.close();
			sourceConn.disconnect();

			System.out.println(response.toString());
		} else if (sourceResponseCode != 200) {
			Reader ir = new InputStreamReader(sourceConn.getErrorStream());
			BufferedReader in = new BufferedReader(ir);
			String inputLine;
			StringBuffer response = new StringBuffer();

			while ((inputLine = in.readLine()) != null) {
				response.append(inputLine);
			}

			in.close();
			sourceConn.disconnect();
			throw new RuntimeException(response.toString());
		}
	}

}
